Index: compiler/gcc.hpp
===================================================================
--- compiler/gcc.hpp	(revision 48858)
+++ compiler/gcc.hpp	(working copy)
@@ -91,6 +91,15 @@
 #if __GNUC__ > 3 || ( __GNUC__ == 3 && __GNUC_MINOR__ >= 1 )
 #define BOOST_HAS_NRVO
 #endif
+//
+// RTTI and typeinfo detection is possible post gcc-4.3:
+//
+#if __GNUC__ * 100 + __GNUC_MINOR__ >= 403
+#  ifndef __GXX_RTTI
+#     define BOOST_NO_TYPEID
+#     define BOOST_NO_RTTI
+#  endif
+#endif
 
 //
 // C++0x features
Index: compiler/visualc.hpp
===================================================================
--- compiler/visualc.hpp	(revision 48858)
+++ compiler/visualc.hpp	(working copy)
@@ -123,6 +123,9 @@
 #ifndef _MSC_EXTENSIONS
 #  define BOOST_DISABLE_WIN32
 #endif
+#ifndef _CPPRTTI
+#  define BOOST_NO_RTTI
+#endif
 
 //
 // all versions support __declspec:
Index: suffix.hpp
===================================================================
--- suffix.hpp	(revision 48858)
+++ suffix.hpp	(working copy)
@@ -158,6 +158,13 @@
 #endif
 
 //
+// Without typeid support we have no dynamic RTTI either:
+//
+#if defined(BOOST_NO_TYPEID) && !defined(BOOST_NO_RTTI)
+#  define BOOST_NO_RTTI
+#endif
+
+//
 // If we have a standard allocator, then we have a partial one as well:
 //
 #if !defined(BOOST_NO_STD_ALLOCATOR)
